// BPOParamters.h: interface for the CBPOParamters class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PLUGIN_CBP_PARAMETERS
#define PLUGIN_CBP_PARAMETERS

class CBPOSubItem //get the changed state of the channel
{
public:
	CBPOSubItem();
	virtual ~CBPOSubItem();

public:
	CString			m_strItemName;	//sub item name
	int				m_nItemChannel;	//sub item channel id
	int				m_nTotalSize;	//ViewRamSize
	CArray<unsigned int,unsigned  int>*		m_pItemArray;//sub item data ary point

	//reserver
	int				m_nReserve1;
	int				m_nReserve2;
	int				m_nReserve3;
	int				m_nReserve4;
	int				m_nReserve5;
	int				m_nReserve6;
	unsigned int	m_uReserve1;
	unsigned int	m_uReserve2;
	unsigned int	m_uReserve3;
	unsigned int	m_uReserve4;
	unsigned int	m_uReserve5;
	unsigned int	m_uReserve6;
	bool			m_bReserve1;
	bool			m_bReserve2;
	bool			m_bReserve3;
	bool			m_bReserve4;
	double			m_dReserve1;
	double			m_dReserve2;
	CString			m_strReserve1;
	CString			m_strReserve2;

public:
	//signal ary operator function
	int					GetAryCount();//get the unit sum of the channel data array
	unsigned int				GetFirstData(unsigned int nPos,int &nArrayPos,bool &bSignal,unsigned int &nTotal);//get ArrayPos,Signal,Total according to address
	unsigned int				GetNextData(int nArray,bool &bSignal);//get the next signal and total of the appointed array
	unsigned int				GetPreData(int nArray, bool &bSignal);//get the previous signal and total of the appointed array
	unsigned int				GetCurData(int nArray, bool &bSignal);//get the signal and total of the appointed array
	int					GetAryIndexByPos(unsigned int nPos);  //get ArrayPos according to address
	unsigned int				GetPosByAryIndex(int nArrayIndex);    //get address according to ArrayPos
	unsigned int				GetPosByPos(unsigned int nPos);       //Read the value of "pos" according to the Ramsize/get address according to address
	bool					GetPerData(unsigned int nPos,bool &bSignal);//read the signal according to address
	int					GetPerSignal(unsigned int nPos);//read the signal according to address
	int					GetEdgeType(unsigned int pos);  //confirm whether it is the signal edge according to address
	bool					RaisingEdge(unsigned int pos);  //confirm whether the input address is Rising
	bool					FallingEdge(unsigned int pos);  //confirm whether the input address is Falling
	int					BinarySearch(unsigned int nValue,int nLow,int nHigh,int nLimit);//find the value of "Ary" by the binary search	
};

class CBPOParamters  //get the data of the software
{
public:
	CBPOParamters();
	virtual ~CBPOParamters();
public:
	//bus sub item
	CArray<CBPOSubItem*,CBPOSubItem*>*	m_pSubItemAry;
	//bus parameters
	int				m_nBusSubCount;    //Bus count
	CString			m_strBusName;      //Bus Name
	CArray<unsigned int,unsigned int>*	m_pAddressAry; //address array
	CArray<__int64,__int64>*			m_pDataAry;    //data array
	CArray<short,short>*				m_pFlagAry;    //flag array
	CArray<COLORREF,COLORREF>*			m_pColorAry;   //color array
	void		FreeArray();      //void
	int			GetUnknowSize();  //get the start position of the waveform
	//pulbic parameters
	unsigned int	m_nRamsize;   //the maximal Ramsize
	double			m_nFre;       //frequency value
	bool			m_bUnknow;    //unknow flag
	int				m_nUnknowSize;//unknow size
	int				m_nLanguage;  //soft language interface 1 SI,2 Tr,3English
	int				m_nLaVersion; //version
	bool			m_bDsdp;      //whether activate the function of "Select Analysis Range" of Software or not
	unsigned int	m_nDs;        //the position of Ds in the waveform
	unsigned int	m_nDp;        //the position of Dp in the waveform

	//reserver
	int				m_nReserve1;
	int				m_nReserve2;
	int				m_nReserve3;
	int				m_nReserve4;
	int				m_nReserve5;
	int				m_nReserve6;
	unsigned int	m_uReserve1;
	unsigned int	m_uReserve2;
	unsigned int	m_uReserve3;
	unsigned int	m_uReserve4;
	unsigned int	m_uReserve5;
	unsigned int	m_uReserve6;
	bool			m_bReserve1;
	bool			m_bReserve2;
	bool			m_bReserve3;
	bool			m_bReserve4;
	double			m_dReserve1;
	double			m_dReserve2;
	CString			m_strReserve1;
	CString			m_strReserve2;
};

#endif PLUGIN_CBP_PARAMETERS 
