// DATABUS.cpp
#include "stdafx.h"
#include "math.h"
#include "BusData.h"
#include "BPOParamters.h"
#include "BusDataArray.h"
#include "sample_param_data.h"
#include "Setup.h"

//define  const Flag
#define LABEL_UNKNOW	1
#define LABEL_DATA		4000
//====================================================================================
//inside function define start
//////////////////////////////////////////////////////////////////////////////////////
// module function
DATABUSMODULE *GetModule();
bool VidPid(unsigned short vid,unsigned short pid);
bool supportcheck(struct _DataBusModule *this_mod,int nVersion);
void config(DATABUSMODULE *this_mod);
int init(DATABUSMODULE *this_mod, void* BPOP);
bool DoBus(DATABUSMODULE *this_mod,void* pObject);
void CleanBus(DATABUSMODULE *this_mod);
void quit(DATABUSMODULE *this_mod);
void SetParamBuf(void *pbuf,int size);
void* GetParamBuf(int &size);
void SetBusTriParamBuf(void *pbuf,int size);
void* GetBusTriParamBuf(int &size);
int GetUnitCount();
void GetUnit(int nIndex,int &nFlag,COLORREF &clr,char *name,unsigned int &bitcount);
bool CheckSerial(char *sn);
bool PlugEnableUse();
int LeastSingalNum();
bool BusListUnitShow(short nFlag);
bool BusListUnitName(short nFlag,char *name);
bool BusListUnitClr(short nFlag,COLORREF &clr);
bool BusListPackStart(short nFlag);
bool BusListPackEnd(short nFlag);
bool BusListDesShow();
bool BusListDesFlag(short nFlag,char *name);
int Reserve0(void);
int Reserve1(void);
int Reserve2(void);
int Reserve3(void);
int Reserve4(void);
int Reserve5(int value);
int Reserve6(int value);
int Reserve7(int value);
bool Reserve8(void);
bool Reserve9(void);
void* Reserve10(void* pdata);
void* Reserve11(void* pdata);
void* Reserve12(void* pdata);
void* Reserve13(void* pdata);
void* Reserve14(void* pdata);

//inside function
bool AnalyData();                 //control and deal with the decoding mode of the module
COLORREF Getclr(int nFlag);          //get the corresponding color value of "unit" by FLAG mark
bool Setclr(int nIndex,COLORREF clr);//set the color of "unit" structure
bool SetName(int nIndex,char *name); //set the name of "unit" structure 

int	Add(unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr);//display the decoding information in the packet 
unsigned int m_nSize=0;
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//exported function define end


//====================================================================================
//inside members  start
//////////////////////////////////////////////////////////////////////////////////////
//header
DATABUSHEADER hdr = 
{
	BUS_VER,
		"LA Sample_Demo MODULE V1.00.00",		//describe the name of the present module version   Step 1.Modify the name of the module		
		"Sample_Demo",								//module name
		"Sample",						//the mark of the save
		0,
		0,
		0,
		"",
		"",
		GetModule 
};

//module
DATABUSMODULE mod =
{
	"THIS IS MODULE V1.0",
	NULL,	// hwndParent
	NULL,	// hDllInstance

	VidPid,
	supportcheck,
	config,
	init,
	DoBus,
	CleanBus,
	quit,
	SetParamBuf,
	GetParamBuf,
	SetBusTriParamBuf,
	GetBusTriParamBuf,
	GetUnitCount,
	GetUnit,
	CheckSerial,
	PlugEnableUse,
	LeastSingalNum,
	BusListUnitShow,
	BusListUnitName,
    BusListUnitClr,
	BusListPackStart,
	BusListPackEnd,
	BusListDesShow,
	BusListDesFlag,
	Reserve0,
	Reserve1,
	Reserve2,
	Reserve3,
	Reserve4,
	Reserve5,
	Reserve6,
	Reserve7,
	Reserve8,
	Reserve9,
	Reserve10,
	Reserve11,
	Reserve12,
	Reserve13,
	Reserve14,
	NULL
};

//Step 2.The Flag, ColorName and Length of every package
CATEGORYUNIT unit[1] = 
{
	LABEL_DATA,		RGB(45,163,128),	"DATA",			1
};

PLUGINSTATUS pluginstatus = 
{
	true,
	false,
	false,
	false,
	false	
};

//Step 3.Control of the Package
PLUGINBUSLIST buslist[1] = 
{
	true,	RGB(45,163,128),	0,//data	
};

int m_nPluginVersion = 10100;//this is plugin version
CBPOParamters *pBPOParameters;
SAMPLEPARAM sampleparamdata;
CBusDataArray busdata;
unsigned short machinevid = 0;
unsigned short machinepid = 0;
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//inside members end

//====================================================================================
//exported function start
//////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" 
{
#endif
// this is the only exported symbol. returns our main header.
__declspec( dllexport ) DATABUSHEADER *ZPLAGetBusModule()
{
	return &hdr;
}
#ifdef __cplusplus
}
#endif
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//exported function end

//====================================================================================
//inside function start
//////////////////////////////////////////////////////////////////////////////////////
// getmodule routine from the main header. Returns NULL if an invalid module was requested,
// otherwise returns either mod1 or mod2 depending on 'which'.
DATABUSMODULE *GetModule()
{	
	return &mod;
}

bool VidPid(unsigned short vid,unsigned short pid)
{
	machinevid = vid;
	machinepid = pid;
	busdata.SetPid(machinepid);
	return true;
}
bool supportcheck(struct _DataBusModule *this_mod,int nVersion)
{

	return true;
}
// config
void config(DATABUSMODULE *this_mod)
{
	int count =pBPOParameters->m_nBusSubCount;
	if (count<=1)
	{
		AfxMessageBox("The subitem must be more than one of the protocol analyzer");
		return ;
	}

	CSetup dlg;
	if(dlg.DoModal()==IDOK)
	{
		unit[0].color=sampleparamdata.clr;
	}
	return ;	

}

//init func
int init(DATABUSMODULE *this_mod, void* BPOP)
{
	pBPOParameters = (CBPOParamters*)BPOP;
	
	return 0;
}
// cleanup (opposite of init()). Destroys the window, unregisters the window class
void quit(DATABUSMODULE *this_mod)
{

}

//do bus
bool DoBus(DATABUSMODULE *this_mod,void* pObject)
{
	
	//do bus
	AnalyData();
	//ary to point paramters
	pBPOParameters->m_pAddressAry = &busdata.m_aryBusAddress;
	pBPOParameters->m_pDataAry = &busdata.m_aryBusData;
	pBPOParameters->m_pFlagAry = &busdata.m_aryBusFlag;
	pBPOParameters->m_pColorAry = &busdata.m_aryBusClr;
	return true;
}

bool AnalyData()
{

	//Step 4.The main function of decoding
	unsigned int nSize = pBPOParameters->m_nRamsize;   //Ramsize
	unsigned int nUnknowSize = pBPOParameters->GetUnknowSize();//start position
	unsigned int pos = nUnknowSize;
	busdata.Clear();//clear all of Bus
	CBPOSubItem* pSubData = NULL;
	CBPOSubItem* pSubClk = NULL;
	CBPOSubItem* pTemItem = NULL;
	if(pBPOParameters->m_bDsdp)//get the start position and end position of the whole Bus by the Ds and Dp
	{
		if(pos < pBPOParameters->m_nDs)
		{
			pos = pBPOParameters->m_nDs;
		}
		nSize = pBPOParameters->m_nDp;
	}
	m_nSize = nSize;
	int subcount = 0;
	Add(0,0,1,Getclr(1));//use UNKNOW to mark the whole Bus

	subcount = pBPOParameters->m_pSubItemAry->GetSize();//get the quantity of the Bus containing subitem
	if(subcount <=1)  return false;
	for(int c = 0; c < subcount; c++)//appoint the suitable channel into SDA and SCL according to the set channel index
	{
		pTemItem = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(c);	
		if(pTemItem->m_nItemChannel == sampleparamdata.index)
			pSubData = pTemItem;
		if(pTemItem->m_nItemChannel == sampleparamdata.clk)
			pSubClk = pTemItem;
	}	
	if(pSubData== NULL || pSubClk == NULL)//drag the channel out and appoint the the first and second channel of Bus into SDA and SCL respectively when there is not the channel in the subitem of the Bus  
	{
		pSubClk = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(0);
		pSubData = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(1);
		sampleparamdata.clk = pSubClk->m_nItemChannel;
		sampleparamdata.index = pSubData->m_nItemChannel;
	}

	UINT index = pSubClk->GetAryIndexByPos(pos);
	pos = pSubClk->GetPosByAryIndex(index);
	while(pos < nSize)
	{
		int value = pSubData->GetPerSignal(pos);
		busdata.Add(pos,value,LABEL_DATA,Getclr(LABEL_DATA));
		index++;
		pos = pSubClk->GetPosByAryIndex(index);
	}


	return true;
}
int	Add(unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr)
{
	unsigned int pos = nAddress;
	if(pos > m_nSize)
	{
		pos = m_nSize;
		return 0;
	}
	if(busdata.MatchLastFlag(nFlag))//IIC is used to identify two seriate FLAG
	{
		return 0;
	}
	return busdata.Add(pos,nValue,nFlag,clr);
}
void CleanBus(DATABUSMODULE *this_mod)
{
	busdata.Clear();
}
//--------------------------------------------------------
//get unit count
int GetUnitCount()
{
	return 1;
}
//get single unit
void GetUnit(int nIndex,int &nFlag,COLORREF &clr,char *name,unsigned int &bitcount)
{
	nFlag = unit[nIndex].flag;
	clr = unit[nIndex].color;
	strcpy(name, unit[nIndex].name);
	strcpy(name, unit[nIndex].name);
	bitcount = unit[nIndex].bitcount;
}
COLORREF Getclr(int nFlag)
{
	int Count = 0;
	Count = GetUnitCount();
	for(int i = 0; i < Count; i++)
	{
		if(unit[i].flag == nFlag)
		{
			return unit[i].color;
		}
	}
	return 0;
}
bool Setclr(int nIndex,COLORREF clr)
{ 
	int Count = 0;
	Count = GetUnitCount();
	if(nIndex >= Count)return false;
	unit[nIndex].color = clr;
	return true;
}
bool SetName(int nIndex,char* name)
{
	int Count = 0;
	Count = GetUnitCount();
	if(nIndex >= Count)return false;
	strcpy(unit[nIndex].name, name);
	return true;
}
//copy the parameters from app
void SetParamBuf(void *pbuf,int size)
{
	int iicsize = sizeof(_sampleparam);
	if(iicsize != size)return;
	CopyMemory(pbuf,&sampleparamdata,iicsize);
}
//to get parameters data
void* GetParamBuf(int &size)
{
	size = sizeof(_sampleparam);
	return &sampleparamdata;
}
//copy the bus trigger parameters from app
void SetBusTriParamBuf(void *pbuf,int size)
{
	int iicsize = sizeof(_sampleparam);
	if(iicsize != size)return;
	CopyMemory(pbuf,&sampleparamdata,iicsize);
}
//to get parameters data
void* GetBusTriParamBuf(int &size)
{
	size = sizeof(_sampleparam);
	return &sampleparamdata;
}
bool PlugEnableUse()
{
	if(pluginstatus.bFree)
	{
		return true;
	}
	else
	{
		if(pluginstatus.bReg)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}
//check serial number
bool CheckSerial(char *sn)
{
	pluginstatus.bReg=true;
	return false;
}

int LeastSingalNum()
{
	return 2;
}
//----------------------------------------------------------
bool BusListUnitShow(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_DATA:
		return buslist[0].bShow;
	default:
		break;
	}
	return true;
}
bool BusListUnitName(short nFlag,char *name)
{
	switch(nFlag) 
	{
	case LABEL_DATA:
		strcpy(name, "DATA");
		break;
	
	default:
		break;
	}
	return true;
}
bool BusListUnitClr(short nFlag,COLORREF &clr)
{
	switch(nFlag) 
	{
	case LABEL_DATA:
		clr = buslist[0].clr;
		break;
	default:
		break;
	}
	return true;
}
bool BusListPackStart(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_DATA:
		return true;
	default:
		break;
	}
	return false;
}
bool BusListPackEnd(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_DATA:
		return true;
	default:
		break;
	}
	return false;
}
bool BusListDesShow()
{
	return false;
	//return buslist[1].bShow;
}
bool BusListDesFlag(short nFlag,char *name)
{
	
	return false;
}
//-------------------------------------------------------------
//reserve function
int Reserve0(void)
{
	return 0;
}
int Reserve1(void)
{
	return 0;
}
int Reserve2(void)
{
	return 0;
}
int Reserve3(void)
{
	return 0;
}
int Reserve4(void)
{
	return 0;
}
int Reserve5(int value)
{
	return 0;
}
int Reserve6(int value)
{
	return 0;
}
int Reserve7(int value)
{
	return 0;
}
bool Reserve8(void)
{
	return false;
}
bool Reserve9(void)
{
	return false;
}
void* Reserve10(void* pdata)
{
	return pdata;
}
void* Reserve11(void* pdata)
{
	return pdata;
}
void* Reserve12(void* pdata)
{
	return pdata;
}
void* Reserve13(void* pdata)
{
	return pdata;
}
void* Reserve14(void* pdata)
{
	return pdata;
}

//When defining the String Table, it will use three kinds of language to do declaration. Refer to the below.
//IDS_CHANNEL_INVALID_EN  14
//IDS_CHANNEL_INVALID_SI  15
//IDS_CHANNEL_INVALID_TR  16
//It is notice that loading the English String is ok when using the String Table.

CString MessageStringTable(UINT ID)
{
	
	CString str;
	switch(pBPOParameters->m_nLanguage)
	{		
	case 1:
		str.LoadString(ID+1);   //SI
		break;
	case 2:	
		str.LoadString(ID+2); //TR
		break;
	case 3:	
		str.LoadString(ID); //En
		break; 
	default:
		str.LoadString(ID); //En
		break;
	}
	return str;	
}
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//inside function end