//********************************************************************
// LA BUSDATA plugin interface

// notes:
// any window that remains in foreground should optimally pass unused
// keystrokes to the parent window, so that the user
// can still control it. As for storing configuration,
// Configuration data should be stored in <dll directory>\plugin.ini
// (look at the vis plugin for configuration code)
//********************************************************************
#ifndef PLUGIN_DATA
#define PLUGIN_DATA
//#define EXPORTED_DLL_FUNCTION __declspec(dllexport) __stdcall

typedef struct _DataBusModule  //Bus Data Module Interface
{
  char *description;		// description
  HWND hwndParent;			// parent window (filled in by calling app)
  HINSTANCE hDllInstance;	// instance handle to this DLL (filled in by calling app)

  bool (*VidPid)(unsigned short vid,unsigned short pid);//The software will be connected with the hardware
  bool (*supportcheck)(struct _DataBusModule *this_mod,int nVersion);//Check the version whether to need the Register number
  void (*Config)(struct _DataBusModule *this_mod);  // configuration dialog (if needed)
  int (*Init)(struct _DataBusModule *this_mod, void* BPOP);     // 0 on success, creates window, etc (if needed)
  bool (*DoBus)(struct _DataBusModule *this_mod,void* pObject);
  void (*CleanBus)(struct _DataBusModule *this_mod); //Clear package displaying in the Bus 
  void (*Quit)(struct _DataBusModule *this_mod);    // called when unloading
  void (*SetParamBuf)(void *pbuf,int size);
  void* (*GetParamBuf)(int &size);
  void (*SetBusTriParamBuf)(void *pbuf,int size);
  void* (*GetBusTriParamBuf)(int &size);
  int (*GetUnitCount)();                               //get unit count
  void (*GetUnit)(int nIndex,int &nFlag,COLORREF &clr,char *name,unsigned int &bitcount);////get single unit
  bool (*CheckSerial)(char *sn);
  bool (*PlugEnableUse)();                            //Get the Right of using the module for users 
  int (*LeastSingalNum)();				              //The necessary and Least signal number
  bool (*BusListUnitShow)(short nFlag);               //The appointed Flag characters serial will be displayed
  bool (*BusListUnitName)(short nFlag,char *name);    //The characters serial of Unit name
  bool (*BusListUnitClr)(short nFlag,COLORREF &clr);  //the below color of unit Name
  bool (*BusListPackStart)(short nFlag);			  //The start flag of package 
  bool (*BusListPackEnd)(short nFlag);				  //The end flag of package 
  bool (*BusListDesShow)();							  //Whether to display the description
  bool (*BusListDesFlag)(short nFlag,char *name);	  //The Flag of necessary description, such as: LABEL_DATANACK 
  int (*Reserve0)(void);                              //The default function as below 
  int (*Reserve1)(void);
  int (*Reserve2)(void);
  int (*Reserve3)(void);
  int (*Reserve4)(void);
  int (*Reserve5)(int value); 
  int (*Reserve6)(int value);
  int (*Reserve7)(int value);
  bool (*Reserve8)(void);
  bool (*Reserve9)(void);
  void* (*Reserve10)(void* pdata);
  void* (*Reserve11)(void* pdata);
  void* (*Reserve12)(void* pdata);
  void* (*Reserve13)(void* pdata);
  void* (*Reserve14)(void* pdata);
  void*	userData; // user data, optional
} DATABUSMODULE;

typedef struct _DataBusHeader//It is used to control module type of different versions 
{
  int version;       // BUS_VER
  char *description; //The description of the current module version name 
  char *ico;         //Module Name 
  char *specialid;   //The discrimination characters of Save file 
  int reserve0;      //The default variable as below
  int reserve1;
  int reserve2;
  char *reserve3;
  char *reserve4;
  DATABUSMODULE* (*GetModule)();	//Module Reset function
} DATABUSHEADER;

//category unit data
typedef struct _CategoryUnit//Control the specific display of package for waveform 
{
	int flag;		        //Category flag
	COLORREF color;		    //Category color
	char name[MAX_PATH];	//Category name
	unsigned int bitcount;  //Category bit count
} CATEGORYUNIT; 

//plugin status
typedef struct _PluginStatus//Control whether the module is need to register or free
{
	bool bFree;   //Whether it is free or not
	bool bReg;    //Whether it is need to register 
	bool bStaus1; //The default variable as below 
	bool bStaus2;
	bool bStaus3;	
} PLUGINSTATUS;

typedef struct _PluginBusList//It is used to control the color of package page and display type
{
	bool bShow;   //Wehter it is to show or not
	COLORREF clr; //COLOR
	int bStaus1;  //The default variable is unusable
}PLUGINBUSLIST;

// exported symbols
typedef DATABUSHEADER* (*GetBusDataHeader)();

// header version: 10600 == V1.06.00
#define BUS_VER 10600

#endif PLUGIN_DATA