// BPOParamters.h: interface for the CBPOParamters class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PLUGIN_CBP_PARAMETERS
#define PLUGIN_CBP_PARAMETERS

class CBPOSubItem
{
public:
	CBPOSubItem();
	virtual ~CBPOSubItem();

public:
	CString			m_strItemName;//sub item name
	int				m_nItemChannel;//sub item channel id
	int				m_nTotalSize;//ViewRamSize
	CArray<unsigned int,unsigned  int>*		m_pItemArray;//sub item data ary point

	//reserver
	int				m_nReserve1;
	int				m_nReserve2;
	int				m_nReserve3;
	int				m_nReserve4;
	int				m_nReserve5;
	int				m_nReserve6;
	unsigned int	m_uReserve1;
	unsigned int	m_uReserve2;
	unsigned int	m_uReserve3;
	unsigned int	m_uReserve4;
	unsigned int	m_uReserve5;
	unsigned int	m_uReserve6;
	bool			m_bReserve1;
	bool			m_bReserve2;
	bool			m_bReserve3;
	bool			m_bReserve4;
	double			m_dReserve1;
	double			m_dReserve2;
	CString			m_strReserve1;
	CString			m_strReserve2;

public:
	//signal ary operator function
	int							GetAryCount();
	unsigned int				GetFirstData(unsigned int nPos,int &nArrayPos,bool &bSignal,unsigned int &nTotal);//According to the value of the Ram size, start to read the state value of the first signal.   
	unsigned int				GetNextData(int nArray,bool &bSignal);//According to the ch Ary Index, read the state value of signal of the next ch.
	unsigned int				GetPreData(int nArray, bool &bSignal);//According to the ch Ary Index, read the state value of signal of the previous ch. 
	unsigned int				GetCurData(int nArray, bool &bSignal);//According to the ch Ary Index, read the state value of signal of the current ch. 
	int							GetAryIndexByPos(unsigned int nPos);//According to the Ram size, read the value of the ch ary. 
	unsigned int				GetPosByAryIndex(int nArrayIndex);//According to the ch Ary Index, read the value of the pos.
	unsigned int				GetPosByPos(unsigned int nPos);//According to the Ram size, read the value of the pos.
	bool						GetPerData(unsigned int nPos,bool &bSignal);//According to the Ram Size Index, read the state of signal of each ch. 
	int							GetPerSignal(unsigned int nPos);
	int							GetEdgeType(unsigned int pos);
	bool						RaisingEdge(unsigned int pos);
	bool						FallingEdge(unsigned int pos);
	int							BinarySearch(unsigned int nValue,int nLow,int nHigh,int nLimit);//Binary Search, search the value of Ary.	
};

class CBPOParamters  
{
public:
	CBPOParamters();
	virtual ~CBPOParamters();

public:
	//bus sub item
	CArray<CBPOSubItem*,CBPOSubItem*>*	m_pSubItemAry;

	//bus parameters
	int				m_nBusSubCount;
	CString			m_strBusName;

	CArray<unsigned int,unsigned int>*	m_pAddressAry;
	CArray<__int64,__int64>*			m_pDataAry;
	CArray<short,short>*				m_pFlagAry;
	CArray<COLORREF,COLORREF>*			m_pColorAry;
	void		FreeArray();
	int			GetUnknowSize();
	//pulbic parameters
	unsigned int	m_nRamsize;//ramsize 
	double			m_nFre;//frequency
	bool			m_bUnknow;//unknow flag
	int				m_nUnknowSize;//unknow size
	int				m_nLanguage;//soft language interface 1 SI,2 Tr,3English
	int				m_nLaVersion;// Main program version
	bool			m_bDsdp;
	unsigned int	m_nDs;
	unsigned int	m_nDp;

	//reserver
	int				m_nReserve1;
	int				m_nReserve2;
	int				m_nReserve3;
	int				m_nReserve4;
	int				m_nReserve5;
	int				m_nReserve6;
	unsigned int	m_uReserve1;
	unsigned int	m_uReserve2;
	unsigned int	m_uReserve3;
	unsigned int	m_uReserve4;
	unsigned int	m_uReserve5;
	unsigned int	m_uReserve6;
	bool			m_bReserve1;
	bool			m_bReserve2;
	bool			m_bReserve3;
	bool			m_bReserve4;
	double			m_dReserve1;
	double			m_dReserve2;
	CString			m_strReserve1;
	CString			m_strReserve2;
};

#endif PLUGIN_CBP_PARAMETERS 
