// DATABUS.cpp
#include "stdafx.h"
#include "math.h"
#include "BusData.h"
#include "IIC_PARAM_DATA.h" //iic paramters
#include "BPOParamters.h"
#include "BusDataArray.h"
#include "IICSetupSheet.h"
#include "MSCustizeSizeRulePara.h"
#include "MSCustizeRulePara.h"
#include "MSParamters.h"

//define IIC const Flag
#define LABEL_START		3000
#define LABEL_ADDRESS	4000
#define LABEL_READ		3001
#define LABEL_WRITE		3002
#define LABEL_ADDRACK	3003
#define LABEL_ADDRNACK	3004
#define LABEL_DATA		4001
#define LABEL_REGADDR	4002
#define LABEL_DATAACK	3005
#define LABEL_DATANACK	3006
#define LABEL_STOP		3007
#define LABEL_UNKNOW	1
//====================================================================================
//inside function define start
//////////////////////////////////////////////////////////////////////////////////////
// module function
DATABUSMODULE *GetModule();
bool VidPid(unsigned short vid,unsigned short pid);
bool supportcheck(struct _DataBusModule *this_mod,int nVersion);
void config(DATABUSMODULE *this_mod);
int init(DATABUSMODULE *this_mod, void* BPOP);
bool DoBus(DATABUSMODULE *this_mod,void* pObject);
void CleanBus(DATABUSMODULE *this_mod);
void quit(DATABUSMODULE *this_mod);
void SetParamBuf(void *pbuf,int size);
void* GetParamBuf(int &size);
void SetBusTriParamBuf(void *pbuf,int size);
void* GetBusTriParamBuf(int &size);
int GetUnitCount();
void GetUnit(int nIndex,int &nFlag,COLORREF &clr,char *name,unsigned int &bitcount);
bool CheckSerial(char *sn);
bool PlugEnableUse();
int LeastSingalNum();
bool BusListUnitShow(short nFlag);
bool BusListUnitName(short nFlag,char *name);
bool BusListUnitClr(short nFlag,COLORREF &clr);
bool BusListPackStart(short nFlag);
bool BusListPackEnd(short nFlag);
bool BusListDesShow();
bool BusListDesFlag(short nFlag,char *name);
int Reserve0(void);
int Reserve1(void);
int Reserve2(void);
int Reserve3(void);
int Reserve4(void);
int Reserve5(int value);
int Reserve6(int value);
int Reserve7(int value);
bool Reserve8(void);
bool Reserve9(void);
void* Reserve10(void* pdata);
void* Reserve11(void* pdata);
void* Reserve12(void* pdata);
void* Reserve13(void* pdata);
void* Reserve14(void* pdata);

//inside function
bool AnalyIICData();
COLORREF Getclr(int nFlag);
bool Setclr(int nIndex,COLORREF clr);
bool SetName(int nIndex,char *name);
CString MessageStringTable(UINT ID);

int	Add(unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr);
unsigned int m_nSize=0;
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//exported function define end


//====================================================================================
//inside members  start
//////////////////////////////////////////////////////////////////////////////////////
//header
DATABUSHEADER hdr = 
{
	BUS_VER,
		"LA SAMPLE IIC MODULE V1.00",		//describe the name of the present module version   Step 1.Modify the name of the module		
		"SAMPLE",								//module name
		"Samplev10000",						//the mark of the save
		0,
		0,
		0,
		"",
		"",
		GetModule 
};

//module
DATABUSMODULE mod =
{
	"THIS IS MODULE V1.0",
	NULL,	// hwndParent
	NULL,	// hDllInstance

	VidPid,
	supportcheck,
	config,
	init,
	DoBus,
	CleanBus,
	quit,
	SetParamBuf,
	GetParamBuf,
	SetBusTriParamBuf,
	GetBusTriParamBuf,
	GetUnitCount,
	GetUnit,
	CheckSerial,
	PlugEnableUse,
	LeastSingalNum,
	BusListUnitShow,
	BusListUnitName,
    BusListUnitClr,
	BusListPackStart,
	BusListPackEnd,
	BusListDesShow,
	BusListDesFlag,
	Reserve0,
	Reserve1,
	Reserve2,
	Reserve3,
	Reserve4,
	Reserve5,
	Reserve6,
	Reserve7,
	Reserve8,
	Reserve9,
	Reserve10,
	Reserve11,
	Reserve12,
	Reserve13,
	Reserve14,
	NULL
};

CATEGORYUNIT unit[12] = 
{
	LABEL_START,	RGB(102,204,204),	"START",		0,
	LABEL_ADDRESS,	RGB(249,114,29),	"ADDRESS",	    7,
	LABEL_READ,		RGB(60,125,253),	"READ",			0,
	LABEL_WRITE,	RGB(230,73,89),		"WRITE",		0,
	LABEL_ADDRACK,	RGB(255,0,128),		"A-ACK",		0,
	LABEL_ADDRNACK,	RGB(249,117,142),	"A-NACK",		0,
	LABEL_DATA,		RGB(51,204,51),		"DATA",			8,
	LABEL_DATAACK,	RGB(138,206,137),	"D-ACK",		0,
	LABEL_DATANACK,	RGB(171,203,95),	"D-NACK",		0,
	LABEL_STOP,		RGB(204,0,0),		"STOP",			0,
	LABEL_UNKNOW,	RGB(51,51,51),		"UNKNOW",		0,
	LABEL_REGADDR,	RGB(43,207,255),	"REG ADDR",		8
};

PLUGINSTATUS pluginstatus = 
{
	true,
	false,
	false,
	false,
	false	
};

PLUGINBUSLIST buslist[10] = 
{
	true,	RGB(249,114,29),	0,//address
	true,	RGB(60,125,253),	0,//read
	true,	RGB(255,0,128),		0,//address ack
	true,	RGB(51,204,51),		0,//data
	true,	RGB(138,206,137),	0,//data ack
	true,	RGB(230,73,89),		0,//write
	true,	RGB(249,117,142),	0,//address Nack
	true,	RGB(171,203,95),	0,//Data Nack
	true,	RGB(5,5,255),		0,//describe
	true,	RGB(43,207,255),	0//REGADDR
};

int m_nPluginVersion = 10100;//this is plugin version
CBPOParamters *pBPOParameters;
CMSParamters  *pMSParameters;
IICPARAM iicparamdata;
CBusDataArray busdata;
CMSCustomizePara		*pMSCustPara;
CMSCustomizeSizePara	*pMSCustSizePara;
unsigned short machinevid = 0;
unsigned short machinepid = 0;
char machineSN[50];

//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//inside members end

//====================================================================================
//exported function start
//////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" 
{
#endif
// this is the only exported symbol. returns our main header.
__declspec( dllexport ) DATABUSHEADER *ZPLAGetBusModule()
{
	return &hdr;
}
#ifdef __cplusplus
}
#endif
//////////////////////////////////////////////////////////////////////////////////////
//====================================================================================
//exported function end

//====================================================================================
//inside function start
//////////////////////////////////////////////////////////////////////////////////////
// getmodule routine from the main header. Returns NULL if an invalid module was requested,
// otherwise returns either mod1 or mod2 depending on 'which'.
DATABUSMODULE *GetModule()
{	
	return &mod;
}

bool VidPid(unsigned short vid,unsigned short pid)
{
	machinevid = vid;
	machinepid = pid;
	busdata.SetPid(machinepid);
	return true;
}

bool supportcheck(struct _DataBusModule *this_mod,int nVersion)
{	
	return true;
}

// config
void config(DATABUSMODULE *this_mod)
{
	int count =pBPOParameters->m_nBusSubCount;
	if (count<=1)
	{
		AfxMessageBox(MessageStringTable(IDS_CHANNEL_INVALID_EN));
		return ;
	}
	CString  str;
	str=MessageStringTable(IDS_SHEET_TITLEEN);
	str=str+pBPOParameters->m_strBusName;
	
	CIICSetupSheet		IICSheet(str);
	if (IICSheet.DoModal()==IDOK)
	{
		strcpy(unit[6].name,iicparamdata.GetDataName());
		strcpy(unit[1].name,iicparamdata.GetAddressName());
        
		unit[0].color=iicparamdata.clrStart;  //start
		unit[1].color=iicparamdata.m_clrSpecBuscolor1;	  //address
		unit[1].bitcount=iicparamdata.AddressBitCount;

		unit[2].color=iicparamdata.clrRead;   //read
		unit[3].color=iicparamdata.clrWrite;  //write
		unit[4].color=iicparamdata.clrAck;   //addack
		unit[5].color=iicparamdata.m_clrSpecBuscolor2;   //ADDRNACK
		unit[6].color=iicparamdata.clrData;// data
		unit[6].bitcount=iicparamdata.DataBitCount;

		unit[7].color=iicparamdata.m_clrSpecBuscolor3;   //DATAACK
		unit[8].color=iicparamdata.m_clrSpecBuscolor4;   //DATANACK
		unit[9].color=iicparamdata.clrEnd;
		strcpy(unit[11].name,iicparamdata.GetREGADDRName());
		unit[11].color=iicparamdata.m_clrSpecBuscolor5;
		unit[11].bitcount=iicparamdata.m_nSpecNumber8;
	}

}

//init func
int init(DATABUSMODULE *this_mod, void* BPOP)
{
	pBPOParameters = (CBPOParamters*)BPOP;
	
	unit[0].color=iicparamdata.clrStart;  //start
	unit[1].color=iicparamdata.m_clrSpecBuscolor1;	  //address
	unit[1].bitcount=iicparamdata.AddressBitCount;
	
	unit[2].color=iicparamdata.clrRead;   //read
	unit[3].color=iicparamdata.clrWrite;  //write
	unit[4].color=iicparamdata.clrAck;   //addack
	unit[5].color=iicparamdata.m_clrSpecBuscolor2;   //ADDRNACK
	unit[6].color=iicparamdata.clrData;// data
	unit[6].bitcount=iicparamdata.DataBitCount;
	
	unit[7].color=iicparamdata.m_clrSpecBuscolor3;   //DATAACK
	unit[8].color=iicparamdata.m_clrSpecBuscolor4;   //DATANACK
	unit[9].color=iicparamdata.clrEnd;
	unit[11].color=iicparamdata.m_clrSpecBuscolor5;
	return 0;
}
// cleanup (opposite of init()). Destroys the window, unregisters the window class
void quit(DATABUSMODULE *this_mod)
{

}

//do bus
bool DoBus(DATABUSMODULE *this_mod,void* pObject)
{
	unit[6].bitcount = iicparamdata.DataBitCount;
	unit[1].bitcount = iicparamdata.AddressBitCount;
	//do bus
	AnalyIICData();
	//ary to point paramters
	pBPOParameters->m_pAddressAry = &busdata.m_aryBusAddress;
	pBPOParameters->m_pDataAry = &busdata.m_aryBusData;
	pBPOParameters->m_pFlagAry = &busdata.m_aryBusFlag;
	pBPOParameters->m_pColorAry = &busdata.m_aryBusClr;

	return true;
}

bool DecodeStartTime(unsigned int StartPos,CBPOSubItem* pSubItemCLK);// Decode the Timing of START
bool DecodeStopTime(unsigned int StartPos,CBPOSubItem* pSubItemCLK);//Decode the Timing of STOP 
bool DecodeDataTime(unsigned int SCKStartPos,CBPOSubItem* pSubItemSCK,CBPOSubItem* pSubItemSDA);//Decode the Timing of DATA 

bool DecodeStopTime(unsigned int StartPos,CBPOSubItem* pSubItemCLK)
{	
	if( iicparamdata.startuptimebool )
	{		
		double postime=1/(pBPOParameters->m_nFre/1000000.0);      //It is the time beween the double pos. 
		int clkfrontindex=pSubItemCLK->GetAryIndexByPos(StartPos);//It is the Rising Edge in front of the SCL High Level. 
		int clkbackindex=clkfrontindex+1;                         //It is the Falling Edge in back of the SCL High Level. 
		unsigned int clkfrontindexpos=pSubItemCLK->GetPosByAryIndex(clkfrontindex);	
		float   fronttime= ( StartPos - clkfrontindexpos ) * postime; //Front Time  		
		if(   iicparamdata.tsustobool )//The Rising Edge of the SDA corresponds to the Rising Edge in front of the SCL High Level.
		{			
			if( iicparamdata.tsustomin <= fronttime && fronttime <= iicparamdata.tsustomax )						
				return true;					
			else						
				return false;				
		}		
	}
	return true;				
}

bool DecodeStartTime(unsigned int StartPos,CBPOSubItem* pSubItemCLK)
{	
	if( iicparamdata.startuptimebool )
	{		
		double postime=1/(pBPOParameters->m_nFre/1000000.0);      //It is the time between the double pos. 
		int clkfrontindex=pSubItemCLK->GetAryIndexByPos(StartPos);//It is the Rising Edge in front of the SCL High Level. 
		int clkbackindex=clkfrontindex+1;                         //It is the Falling Edge in back of the SCL High Level. 		
		unsigned int clkbackindexpos =pSubItemCLK->GetPosByAryIndex(clkbackindex);		
		float       backtime = ( clkbackindexpos - StartPos  ) * postime; // Back Time
		if( iicparamdata.thdstabool )//The Falling Edge of the SDA corresponds to the Falling Edge in front of the SCL High Level.
		{			
			if( iicparamdata.thdstamin <= backtime && backtime <= iicparamdata.thdstamax )						
				return true;						
			else						
				return false;			
		}							
	}
	return true;				
}

bool DecodeDataTime(unsigned int SCKStartPos,CBPOSubItem* pSubItemSCK,CBPOSubItem* pSubItemSDA)
{	
	bool     timebool = true;
	if( iicparamdata.startuptimebool )
	{			
		double       postime=1/(pBPOParameters->m_nFre/1000000.0);        //The time is between the double pos.
		int sckstartindex= pSubItemSCK->GetAryIndexByPos(SCKStartPos);		
        unsigned int sckfalpos=pSubItemSCK->GetPosByAryIndex(sckstartindex+1);// Start the POS in the SCk Low Level.
		unsigned int sckendpos=pSubItemSCK->GetPosByAryIndex(sckstartindex+2);// Stop the POS in the SCk Low Level.
		int sdastartindex=pSubItemSDA->GetAryIndexByPos(SCKStartPos);
		int sdaendindex  =pSubItemSDA->GetAryIndexByPos(sckendpos);	
        unsigned int sdapos=0;
		float   fronttime= 0;//The first front time. 
		float   backtime = 0;//The first back time.		
	 	for(; sdastartindex <= sdaendindex ;sdastartindex++)
		{
			sdapos=pSubItemSDA->GetPosByAryIndex(sdastartindex);
			if( sckfalpos <= sdapos && sdapos <= sckendpos )//The SDA Index  is among the SCK Low Levels.
			{
				fronttime= ( sdapos   - sckfalpos ) * postime; 
				backtime = ( sckendpos - sdapos   ) * postime; 
				if( iicparamdata.tsudatbool )
				{			
					if( iicparamdata.tsudatmin <= backtime && backtime <= iicparamdata.tsudatmax )						
						timebool = true;						
					else						
						return false;			
				}
				if( iicparamdata.thddatbool )
				{			
					if( iicparamdata.thddatmin <= fronttime && fronttime <= iicparamdata.thddatmax )						
						timebool = true;						
					else						
						return false;				
				}				
			}
		}
	}
    return timebool;
}

bool AnalyIICData()
{
	unsigned short RAISING_EDGE = 0, FALLING_EDGE = 1;
	unsigned int nSize = pBPOParameters->m_nRamsize;;
	unsigned int nUnknowSize = pBPOParameters->GetUnknowSize();
	unsigned int pos = nUnknowSize;
	busdata.Clear();
	CBPOSubItem* pSubItemA = NULL;
	CBPOSubItem* pSubItemB = NULL;
	CBPOSubItem* pTemItem = NULL;

	if(pBPOParameters->m_bDsdp)
	{
		if(pos < pBPOParameters->m_nDs)
		{
			pos = pBPOParameters->m_nDs;
		}
		nSize = pBPOParameters->m_nDp;
	}
	m_nSize = nSize;
	int subcount = 0;
	short  nFlag=LABEL_UNKNOW;
	int count=0;
	Add(0,0,nFlag,Getclr(nFlag));

	subcount = pBPOParameters->m_pSubItemAry->GetSize();
	if(subcount <=1)  return false;
	for(int c = 0; c < subcount; c++)
	{
		pTemItem = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(c);	
		if(pTemItem->m_nItemChannel == iicparamdata.SdaNameIndex)
		{
			pSubItemA = pTemItem;
		}
		if(pTemItem->m_nItemChannel == iicparamdata.SclNameIndex)
		{
			pSubItemB = pTemItem;
		}
	}
	if(pSubItemA == NULL||pSubItemB == NULL)
	{
		pSubItemA = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(0);
		iicparamdata.SdaNameIndex = pSubItemA->m_nItemChannel;
		
		pSubItemB = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(1);
		iicparamdata.SclNameIndex = pSubItemB->m_nItemChannel;
	}
	

	int	i=0,nIndex=0;
	int	nAryIndex=0;
	int	temp=0;
	int	address_bits=iicparamdata.AddressBitCount;
	int data_bits=iicparamdata.DataBitCount;
	BOOL add_shift = iicparamdata.AddressLeftShift;
	BOOL bNackDontCare = iicparamdata.NackDontCare;
	BOOL bReadWriteActive = iicparamdata.ReadWriteActive;
	int Read_Level = iicparamdata.ReadLevel;
	int Write_Level = !Read_Level;
	int Ack_Level = iicparamdata.AckLevel;
	__int64 AddressData=0;
	__int64 data=0;
	int  nAddress=0;

	if(pos > nSize)return false;
//--------------------------------------------------------------------s
	unsigned int unknown_pos = pos;
	unsigned int sda_array_size = pSubItemA->GetAryCount();
	unsigned int unknown_sda_index = pSubItemA->GetAryIndexByPos(unknown_pos);
	unsigned int sda_index = 0;
	if( (unknown_sda_index % 2 == 1) && (unknown_sda_index + 1 < sda_array_size) )
		sda_index = unknown_sda_index + 1;
	else
		sda_index = unknown_sda_index;

	unsigned int sda_start_pos = pSubItemA->GetPosByAryIndex(sda_index);
	unsigned int sda_edge_pos = sda_start_pos;
	if(sda_index + 1 < sda_array_size)
		sda_index = sda_index + 1;


	unsigned int scl_array_size = pSubItemB->GetAryCount();
	unsigned int unknown_scl_index = pSubItemB->GetAryIndexByPos(unknown_pos);
	unsigned int scl_index = 0;
	if( (unknown_scl_index % 2 == 0) && (unknown_scl_index + 1 < scl_array_size) )
		scl_index = unknown_scl_index + 1;
	else
		scl_index = unknown_scl_index;

	unsigned int scl_start_pos = pSubItemB->GetPosByAryIndex(scl_index);
	unsigned int scl_edge_pos = scl_start_pos;
	if(scl_index + 1 < scl_array_size)
		scl_index = scl_index + 1;

	bool bfirst = false;
	bool bdataend = false;
	unsigned int datapos = 0;
	int sda_edge_type = -1 , scl_edge_type = -1;	
	bool timebool=true;
	bool SLAVEADDRbool=false;
    __int64 SLAVEADDRData=0;
    unsigned int SLAVEADDRstartpos=0;	
	bool writebool=false;// Reg addr will be dispalyed in the write bool. 
	for(;pos < nSize;)
	{
		sda_edge_pos = pSubItemA->GetPosByAryIndex(sda_index);
		scl_edge_pos = pSubItemB->GetPosByAryIndex(scl_index);
		pos = min(sda_edge_pos,scl_edge_pos);
		if (pos>=nSize)	return true;//Modify and refresh the bug of the DP overing the range on February 1, 2008.
		if(pos == sda_edge_pos)
		{
			if(sda_index < sda_array_size)
				sda_index = sda_index + 1;
		}
		if(pos == scl_edge_pos)
		{
			if(scl_index < scl_array_size)
				scl_index = scl_index + 1;
		}
//---------------------------------------------------------------------------------e
		sda_edge_type = pSubItemA->GetEdgeType(pos);
		scl_edge_type = pSubItemB->GetEdgeType(pos);
		if(nFlag!=LABEL_START && sda_edge_type == FALLING_EDGE)
		{
			if(pSubItemB->GetPerSignal(pos) == 1)
			{
				if(pSubItemB->GetPerSignal(pos-1) == 1 )
				{					
					if(TRUE == DecodeStartTime(pos,pSubItemB))//START TIMING
					{						
						nFlag=LABEL_START;
						nAryIndex=Add(pos,nFlag,nFlag,Getclr(nFlag));
						count=0;
						timebool=true;						
						continue;
					}
				}
			}
		}
		if(nFlag!=LABEL_STOP && sda_edge_type == RAISING_EDGE)
		{
			if(pSubItemB->GetPerSignal(pos) == 1)
			{
				if(pSubItemB->GetPerSignal(pos-1) == 1)
				{
					if( TRUE == DecodeStopTime(pos,pSubItemB) )//STOP TIMING
					{
						if( SLAVEADDRbool )
						{					
							int SLAVEADDRindex=busdata.GetBusAryByPos(SLAVEADDRstartpos);
							busdata.Modify(SLAVEADDRindex,SLAVEADDRstartpos,SLAVEADDRData,LABEL_REGADDR,Getclr(LABEL_REGADDR));
							SLAVEADDRbool=false;
							SLAVEADDRData=0;
							if( busdata.GetAryCount() > SLAVEADDRindex+1)
							{
								if( busdata.GetBusFlagByAry(SLAVEADDRindex+1) == LABEL_DATAACK)
									busdata.Modify(SLAVEADDRindex+1,busdata.GetBusPosByAry(SLAVEADDRindex+1),0,LABEL_ADDRACK,Getclr(LABEL_ADDRACK));
								else
									busdata.Modify(SLAVEADDRindex+1,busdata.GetBusPosByAry(SLAVEADDRindex+1),0,LABEL_ADDRNACK,Getclr(LABEL_ADDRNACK));
							}
						}						
						nFlag=LABEL_STOP;
						nAryIndex=Add(pos,nFlag,nFlag,Getclr(nFlag));
						count=0;
						//have no stop end pos
						unsigned int idex=pSubItemB->GetAryIndexByPos(pos);
						if((idex >= scl_array_size - 1))
						{							
							return true;
						}						
						//------
						continue;
					}
					else
					{						
						nFlag=LABEL_UNKNOW;
			            nAryIndex=Add(pos,nFlag,nFlag,Getclr(nFlag));
					}
				}
			}
		}
		//stop end pos
		if(nFlag==LABEL_STOP && scl_edge_type == FALLING_EDGE)
		{
			nFlag=LABEL_UNKNOW;
			nAryIndex=Add(pos,nFlag,nFlag,Getclr(nFlag));
			count=0;
			continue;			
		}
		//When the SDA signal is decoded as the last Level, the decoding will be stopped.
		unsigned int tmindex=pSubItemB->GetAryIndexByPos(pos);
		if((tmindex >= scl_array_size - 1) && (nFlag != LABEL_DATAACK) && (nFlag != LABEL_DATANACK))
		{	
			//the end data less	
			unsigned int tmpos;
			nFlag=LABEL_UNKNOW;
			tmpos = pSubItemB->GetPosByAryIndex(scl_array_size - 1);
			Add(tmpos,0,nFlag,Getclr(nFlag));
			return true;
		}

		if(scl_edge_type != RAISING_EDGE)continue;
		int sda_value = pSubItemA->GetPerSignal(pos);
		nFlag=busdata.GetBusFlagByAry(nAryIndex);
		if(LABEL_START==nFlag && timebool == TRUE)
		{
			if(count==0)nAddress=pos;
			if( TRUE == DecodeDataTime(pos,pSubItemB,pSubItemA) )
			{
				if( count < address_bits )
				{
					AddressData += ( sda_value * (int)pow(2,address_bits - count -1));
					count++;	
				}
				if( count >= address_bits )
				{
					if(add_shift == TRUE)
						AddressData <<= 1;
					nFlag=LABEL_ADDRESS;
					nIndex=Add(nAddress,AddressData,nFlag,Getclr(nFlag));					
					nAryIndex=nIndex;
					AddressData=0;
					count=0;
					timebool=true;						
				}			
				continue;
			}
			else	
			{				
				timebool=false;
				nFlag=LABEL_UNKNOW;
				Add(nAddress,0,nFlag,Getclr(nFlag));				
			}
		}
		if(bReadWriteActive && LABEL_ADDRESS==nFlag && timebool == TRUE )
		{
			if(add_shift)
			{
				__int64 temp=busdata.GetBusPerData(nAddress);
				temp = temp | (__int64)sda_value;
				busdata.SetBusAryData(nIndex, temp);
			}
			if( TRUE == DecodeDataTime(pos,pSubItemB,pSubItemA) )
			{
				if(sda_value == Read_Level)
				{
					nFlag=LABEL_READ;
					nAryIndex=Add(pos,1,nFlag,Getclr(nFlag));
					data=0;
					count = 0;					
				}
				else
				{
					nFlag=LABEL_WRITE;
					nAryIndex=Add(pos,0,nFlag,Getclr(nFlag));
					data=0;
					count = 0;
					if(iicparamdata.m_bSpecflag8)
						writebool=true;
				}
				timebool=true;
				continue;
			}
			else
			{		
				timebool=false;
				nFlag=LABEL_UNKNOW;
				Add(pos,0,nFlag,Getclr(nFlag));				
			}
		}
		//Address Ack 
		bool bCondition = false;
		if(bReadWriteActive == TRUE)
			bCondition = ( nFlag == LABEL_READ || nFlag == LABEL_WRITE );
		else
			bCondition = ( nFlag == LABEL_ADDRESS );

		if(bCondition == true && timebool == TRUE)
		{
			if( TRUE == DecodeDataTime(pos,pSubItemB,pSubItemA) )
			{
				if(sda_value==Ack_Level)
				{
					nFlag=LABEL_ADDRACK;
					nAryIndex=Add(pos,0,nFlag,Getclr(nFlag));
					temp=sda_value;
					data=0;
					count = 0;
				}
				else
				{
					nFlag=LABEL_ADDRNACK;
					nAryIndex=Add(pos,0,nFlag,Getclr(nFlag));
					temp=sda_value;
					data=0;
					count = 0;
				}
				timebool=true;
				continue;
			}
			else
			{
				timebool=false;
				nFlag=LABEL_UNKNOW;
				Add(pos,0,nFlag,Getclr(nFlag));	
			}
		}

		if( (LABEL_ADDRACK==nFlag || LABEL_ADDRNACK==nFlag || 
			LABEL_DATAACK==nFlag || LABEL_DATANACK==nFlag) && timebool == TRUE )
		{			
            if(count==0)nAddress=pos;
			if(TRUE == DecodeDataTime(pos,pSubItemB,pSubItemA))
			{
				if(temp == Ack_Level || bNackDontCare) 
				{
					if(count==0)
					{
						nAddress=pos;
						bdataend = true;
						datapos = pos;
					}
					if( iicparamdata.m_bSpecflag8 && writebool )
					{						
						SLAVEADDRstartpos=nAddress;
						//Judge whether there is STOP in the following.							
						bool stopbool=false;
						int bitcount=0;
						int SDAindex=pSubItemA->GetAryIndexByPos(SLAVEADDRstartpos);
						while( 1 )
						{
							unsigned int curpos=pSubItemA->GetPosByAryIndex(SDAindex);
							if( curpos >= nSize)
								break;
							if(pSubItemB->GetPerSignal(curpos) == 1 && pSubItemA->GetEdgeType(curpos) == RAISING_EDGE)
							{								
								if( TRUE == DecodeStopTime(curpos,pSubItemB) )//STOP TIMING		
								{
									stopbool=true;									
									break;
								}								
							}
							SDAindex++;
						}
						
                        if( stopbool )
							bitcount=iicparamdata.m_nSpecNumber8;
						else
						{
							bitcount=data_bits;	
							SLAVEADDRbool=false;							
						}
						if( count < bitcount )
						{
							SLAVEADDRData += ( sda_value * (int)pow(2,bitcount - count -1));
							count++;	
						}
						if( count >= bitcount  )
						{							
							nFlag=LABEL_DATA;
							nAryIndex=Add(SLAVEADDRstartpos,SLAVEADDRData,nFlag,Getclr(nFlag));							
							count=0;
							bdataend = false;
							timebool=true;
							writebool=false;
							SLAVEADDRbool=true;
						}
					}
					else
					{
						if( count < data_bits )
						{
							data += ( sda_value * (int)pow(2,data_bits - count -1));
							count++;	
						}
						if( count >= data_bits )
						{
							nFlag=LABEL_DATA;
							nAryIndex=Add(nAddress,data,nFlag,Getclr(nFlag));							
							data=0;
							count=0;
							bdataend = false;
							timebool=true;
						}	
					}
				}
				continue;			
			}
			else
			{
				timebool=false;
				nFlag=LABEL_UNKNOW;
				Add(nAddress,0,nFlag,Getclr(nFlag));	
			}
		}	

		if(LABEL_DATA==nFlag && timebool == TRUE )
		{
			if(TRUE == DecodeDataTime(pos,pSubItemB,pSubItemA))
			{
				if(sda_value==Ack_Level)
				{
					nFlag=LABEL_DATAACK;
					nAryIndex=Add(pos,0,nFlag,Getclr(nFlag));
					data=0;
					count = 0;
				}
				else
				{
					nFlag=LABEL_DATANACK;
					nAryIndex=Add(pos,0,nFlag,Getclr(nFlag));
					data=0;
					count = 0;
				}
				timebool=true;
				continue;
			}
			else
			{
				timebool=false;
				nFlag=LABEL_UNKNOW;
				Add(pos,0,nFlag,Getclr(nFlag));	
			}
		}
	}

	if(bdataend) 
	{	
		//the end data less	
		nFlag=LABEL_UNKNOW;		
		if(nAddress < nSize)
		{
			Add(nAddress,0,nFlag,Getclr(nFlag));
		}		
	}
	
	return true;
}
int	Add(unsigned int nAddress,__int64 nValue,short nFlag,COLORREF clr)
{
	unsigned int pos = nAddress;
	if(pos > m_nSize)
	{
		pos = m_nSize;
		return 0;
	}
	if(busdata.MatchLastFlag(nFlag))//I2C is used to identify the two continuous Flags.
	{
		return 0;
	}
	return busdata.Add(pos,nValue,nFlag,clr);
}
void CleanBus(DATABUSMODULE *this_mod)
{
	busdata.Clear();
}
//--------------------------------------------------------
//get unit count
int GetUnitCount()
{
	return 12;
}
//get single unit
void GetUnit(int nIndex,int &nFlag,COLORREF &clr,char *name,unsigned int &bitcount)
{
	nFlag = unit[nIndex].flag;
	clr = unit[nIndex].color;
	strcpy(name, unit[nIndex].name);
	if((nIndex == 1) && iicparamdata.AddressLeftShift)
	{
		bitcount = unit[nIndex].bitcount + 1;
	}
	else
	{
		bitcount = unit[nIndex].bitcount;
	}
}
COLORREF Getclr(int nFlag)
{
	int Count = 0;
	Count = GetUnitCount();
	for(int i = 0; i < Count; i++)
	{
		if(unit[i].flag == nFlag)
		{
			return unit[i].color;
		}
	}
	return 0;
}
bool Setclr(int nIndex,COLORREF clr)
{ 
	int Count = 0;
	Count = GetUnitCount();
	if(nIndex >= Count)return false;
	unit[nIndex].color = clr;
	return true;
}
bool SetName(int nIndex,char* name)
{
	int Count = 0;
	Count = GetUnitCount();
	if(nIndex >= Count)return false;
	strcpy(unit[nIndex].name, name);
	return true;
}
//copy the parameters from app
void SetParamBuf(void *pbuf,int size)
{
	int iicsize = sizeof(_iicparam);
	if(iicsize != size)return;
	CopyMemory(pbuf,&iicparamdata,iicsize);
}
//to get parameters data
void* GetParamBuf(int &size)
{
	size = sizeof(_iicparam);
	return &iicparamdata;
}
//copy the bus trigger parameters from app
void SetBusTriParamBuf(void *pbuf,int size)
{
	int iicsize = sizeof(_iicparam);
	if(iicsize != size)return;
	CopyMemory(pbuf,&iicparamdata,iicsize);
}
//to get parameters data
void* GetBusTriParamBuf(int &size)
{
	size = sizeof(_iicparam);
	return &iicparamdata;
}
bool PlugEnableUse()
{
	if(pluginstatus.bFree)
	{
		return true;
	}
	else
	{
		if(pluginstatus.bReg)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

//check serial number
bool CheckSerial(char *sn)
{
	pluginstatus.bReg=true;
	return false;
}

int LeastSingalNum()
{
	return 2;
}
//----------------------------------------------------------
bool BusListUnitShow(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_START:
	case LABEL_STOP:
	case LABEL_UNKNOW:
		return false;
	case LABEL_ADDRESS:
		return buslist[0].bShow;
	case LABEL_READ:
		return buslist[1].bShow;
	case LABEL_ADDRACK:
		return buslist[2].bShow;
	case LABEL_DATA:
		return buslist[3].bShow;
	case LABEL_DATAACK:		
		return buslist[4].bShow;
	case LABEL_WRITE:
		return buslist[5].bShow;
	case LABEL_ADDRNACK:
		return buslist[6].bShow;
	case LABEL_DATANACK:
		return buslist[7].bShow;
	case 0:
		return buslist[8].bShow;
	case LABEL_REGADDR:
		return buslist[9].bShow;
	default:
		break;
	}
	return true;
}
bool BusListUnitName(short nFlag,char *name)
{
	switch(nFlag) 
	{
	case LABEL_ADDRESS:
		strcpy(name, "SLAVE ADDR");
		break;
	case LABEL_DATA:
		strcpy(name, "DATA");
		break;
	case LABEL_WRITE:
		strcpy(name, "WRITE");
		break;
	case LABEL_READ:
		strcpy(name, "READ");
		break;
	case LABEL_ADDRACK:
		strcpy(name, "A-ACK");
		break;
	case LABEL_ADDRNACK:
		strcpy(name, "A-NACK");
		break;
	case LABEL_DATAACK:		
		strcpy(name, "D-ACK");
		break;
	case LABEL_DATANACK:
		strcpy(name, "D-NACK");
		break;		
	case LABEL_REGADDR:
		strcpy(name, "REG ADDR");
		break;
	default:
		break;
	}
	return true;
}
bool BusListUnitClr(short nFlag,COLORREF &clr)
{
	switch(nFlag) 
	{
	case LABEL_ADDRESS:
		clr = buslist[0].clr;
		break;
	case LABEL_DATA:
		clr = buslist[3].clr;
		break;
	case LABEL_READ:
		clr = buslist[1].clr;
		break;
	case LABEL_ADDRACK:		
		clr = buslist[2].clr;
		break;
	case LABEL_DATAACK:		
		clr = buslist[4].clr;
		break;
	case LABEL_WRITE:
		clr = buslist[5].clr;
		break;
	case LABEL_ADDRNACK:
		clr = buslist[6].clr;
		break;
	case LABEL_DATANACK:
		clr = buslist[7].clr;
		break;
	case 0:
		clr = buslist[8].clr;
		break;
	case LABEL_REGADDR:
		clr = buslist[9].clr;
		break;
	default:
		break;
	}
	return true;
}
bool BusListPackStart(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_START:
		return true;
	default:
		break;
	}
	return false;
}
bool BusListPackEnd(short nFlag)
{
	switch(nFlag) 
	{
	case LABEL_STOP:
	case LABEL_UNKNOW:
		return true;
	default:
		break;
	}
	return false;
}
bool BusListDesShow()
{
	return buslist[8].bShow;
}
bool BusListDesFlag(short nFlag,char *name)
{
	CString str;
	switch(nFlag) 
	{
	case LABEL_ADDRNACK:
		str=MessageStringTable(IDS_DES_ADDRESS_EN);
		strcpy(name,str);
		return true;
	case LABEL_DATANACK:
		str=MessageStringTable(IDS_DES_DATA_EN);
		strcpy(name,str);
		return true;
	default:
		break;
	}
	return false;
}
//-------------------------------------------------------------
//reserve function
int Reserve0(void) //return start Flag
{
	return 1;//LABEL_START
}
int Reserve1(void)  //return address Flag
{
	return	2;
}
int Reserve2(void) //return read Flag
{
	return 1;//LABEL_READ
}
int Reserve3(void)  //return write Flag
{
	return 1;//LABEL_WRITE
}
int Reserve4(void) //return data Flag
{
	return 1;//LABEL_DATA
}
int Reserve5(int value)
{
	// The 0x7FFF is added in the High Level.
	//The 1000~1999 represents the common, return to the Address Length directly.
	//The 2000~2999 represents one of the exception, search the max one when there are many Addresses. 
	//The 3000~3999 represents one of the exception, many Addresses are added.
	//The 4000~4999 represents one of the exception, many Addresses are subtracted.

	int length=8; // address
	if( iicparamdata.m_bSpecflag8 )  //When the reg address is activated, take it as standard.
		length=iicparamdata.m_nSpecNumber8;
	else
		length=iicparamdata.AddressBitCount;	//When the reg address is not activated, take the Address as standard.
	int HBit=0x7FFF0000;
	length=HBit+length;

	return length;
	
}
int Reserve6(int value)
{
	return 0;
}

int Reserve7(int value)// For the function of the Packet Filter, the "Return" represents the number of the Unit, the "0" represents Non. 
{
	return 1;
}

bool Reserve8(void) //note: true sustain Dynamic Memory
{
	return true;
}
bool Reserve9(void)
{
	return true;
}
void* Reserve10(void* pdata)
{
	pMSParameters = (CMSParamters*)pdata;
	//Start 1
	pMSParameters->m_objMSStartAry[0]=LABEL_START;
	//Address 2
	pMSParameters->m_objMSAddressAry[0]=LABEL_ADDRESS; //The both can't be switch the position.
	pMSParameters->m_objMSAddressAry[1]=LABEL_REGADDR; 
	//Read 1
	pMSParameters->m_objMSReadAry[0]=LABEL_READ;

	//Write 1
	pMSParameters->m_objMSWriteAry[0]=LABEL_WRITE; 
	//Data
	pMSParameters->m_objMSDataAry[0]=LABEL_DATA;

	pMSParameters->m_nReserve1=41; //The number, "5" represents the multi-device, I2C.
		
	if( iicparamdata.m_bSpecflag8 ) //When the reg address is activated, take it as standard.
		pMSParameters->m_nReserve2=2;
	else
		pMSParameters->m_nReserve2=1;

	pdata=(void*)pMSParameters;

	return pdata;
}
void* Reserve11(void* pdata)
{
	return pdata;
}
void* Reserve12(void* pdata)
{
	return pdata;
}
void* Reserve13(void* pdata)//Save the size of the array of the Flag used the Data Format. 
{
	int sum=0;
	pMSCustSizePara = (CMSCustomizeSizePara*)pdata;	
	pMSCustSizePara->m_bCustomize=iicparamdata.m_ActiveRule;	// Whether the Data Format can be supported to customize. 

	int DATATotal=1,SLAVEADDRTotal=1,REGADDRTotal=1;
	//When the DATATotal is equal to "1", it represents those flags with the same property, they will be displayed with the same Data Format. 
	//For example, the DATA is divided into LABEL_WRITEDATA and LABEL_READDATA.
	//We only need to use the DATA to represent in the design of the Data Format interface. 
	//At that time, the DATATotal should be equal to "2".

	//Description: m_objMSbinaryArySize can save the size of the array of the Flag which uses the Binary Ary. 
	//m_objMSdecimalsArySize: Save the size of the array of the Flag which uses the Decimal Ary. eg:data 
	//m_objMShexArySize: Save the size of the array of the Flag which uses the Hexidecimal Ary. eg:cmd
	//m_objMSASCIIArySize: Save the size of the array of the Flag which uses the ASCII Ary.	
	if (iicparamdata.m_ActiveRule)
	{
		if (iicparamdata.m_DATARule==0)
			pMSCustSizePara->Addbinary(DATATotal);
		else if	(iicparamdata.m_DATARule==1)
			pMSCustSizePara->Adddecary(DATATotal);
		else if	(iicparamdata.m_DATARule==2)
			pMSCustSizePara->Addhexary(DATATotal);
		else if	(iicparamdata.m_DATARule==3)
			pMSCustSizePara->AddASCIIary(DATATotal);
		
		if (iicparamdata.m_SLAVEADDRRule==0)
			pMSCustSizePara->Addbinary(SLAVEADDRTotal);
		else if	(iicparamdata.m_SLAVEADDRRule==1)
			pMSCustSizePara->Adddecary(SLAVEADDRTotal);
		else if	(iicparamdata.m_SLAVEADDRRule==2)
			pMSCustSizePara->Addhexary(SLAVEADDRTotal);
		else if	(iicparamdata.m_SLAVEADDRRule==3)
			pMSCustSizePara->AddASCIIary(SLAVEADDRTotal);

		if (iicparamdata.m_REGADDRRule==0)
			pMSCustSizePara->Addbinary(REGADDRTotal);
		else if	(iicparamdata.m_REGADDRRule==1)
			pMSCustSizePara->Adddecary(REGADDRTotal);
		else if	(iicparamdata.m_REGADDRRule==2)
			pMSCustSizePara->Addhexary(REGADDRTotal);
		else if	(iicparamdata.m_REGADDRRule==3)
			pMSCustSizePara->AddASCIIary(REGADDRTotal);	
		
	}
	pdata=(void*)pMSCustSizePara;
	return pdata;
}
void* Reserve14(void* pdata)//Save the flag which needs to be changed the Data Format.
{
	pMSCustPara = (CMSCustomizePara*)pdata;	
	
	vector<short>		binaryAry;		//Save  the array of the Flag which uses the Binary similarly
	vector<short>		decimalsAry;	//Save the array of the Flag which uses the Decimal Ary. eg:data
	vector<short>		hexAry;			//Save the array of the Flag which uses the Hexidecimal Ary. eg:cmd 
	vector<short>		ASCIIAry;		//Save the array of the Flag which uses the ASCII Ary.
	
	vector<short>		Ary1;		
	vector<short>		Ary2;	
	vector<short>		Ary3;	

	Ary1.push_back(LABEL_DATA);	
	Ary2.push_back(LABEL_ADDRESS);
	Ary3.push_back(LABEL_REGADDR);

	if (iicparamdata.m_DATARule==0)
		binaryAry.insert(binaryAry.end(), Ary1.begin(), Ary1.end());					
	else if	(iicparamdata.m_DATARule==1)
		decimalsAry.insert(decimalsAry.end(), Ary1.begin(), Ary1.end());					
	else if	(iicparamdata.m_DATARule==2)
		hexAry.insert(hexAry.end(), Ary1.begin(), Ary1.end());				
	else if	(iicparamdata.m_DATARule==3)
		ASCIIAry.insert(ASCIIAry.end(), Ary1.begin(), Ary1.end());	
	
	if (iicparamdata.m_SLAVEADDRRule==0)
		binaryAry.insert(binaryAry.end(), Ary2.begin(), Ary2.end());					
	else if	(iicparamdata.m_SLAVEADDRRule==1)
		decimalsAry.insert(decimalsAry.end(), Ary2.begin(), Ary2.end());					
	else if	(iicparamdata.m_SLAVEADDRRule==2)
		hexAry.insert(hexAry.end(), Ary2.begin(), Ary2.end());				
	else if	(iicparamdata.m_SLAVEADDRRule==3)
		ASCIIAry.insert(ASCIIAry.end(), Ary2.begin(), Ary2.end());
	
	if (iicparamdata.m_REGADDRRule==0)
		binaryAry.insert(binaryAry.end(), Ary3.begin(), Ary3.end());					
	else if	(iicparamdata.m_REGADDRRule==1)
		decimalsAry.insert(decimalsAry.end(), Ary3.begin(), Ary3.end());					
	else if	(iicparamdata.m_REGADDRRule==2)
		hexAry.insert(hexAry.end(), Ary3.begin(), Ary3.end());				
	else if	(iicparamdata.m_REGADDRRule==3)
		ASCIIAry.insert(ASCIIAry.end(), Ary3.begin(), Ary3.end());

	pMSCustPara->m_objMSbinaryAry=binaryAry;
	pMSCustPara->m_objMSdecimalsAry=decimalsAry;
	pMSCustPara->m_objMShexAry=hexAry;
	pMSCustPara->m_objMSASCIIAry=ASCIIAry;

	pdata=(void*)pMSCustPara;
	return pdata;
}

// When defining the String Table, there are three language versions. Refer to the below. 
//IDS_CHANNEL_INVALID_EN  14
//IDS_CHANNEL_INVALID_SI  15
//IDS_CHANNEL_INVALID_TR  16
//It is notice that uploading the English String ID is ok when using the String Table.

CString MessageStringTable(UINT ID)
{
	
	CString str;
	switch(pBPOParameters->m_nLanguage)
	{		
	case 1:
		str.LoadString(ID+1);   //SI
		break;
	case 2:	
		str.LoadString(ID+2); //TR
		break;
	case 3:	
		str.LoadString(ID); //En
		break; 
	default:
		str.LoadString(ID); //En
		break;
	}
	return str;	
}
